#include <sourcemod>
#include <sdkhooks>
#include <csgo_colors>
#include <vip_core>
#include <emitsoundany>

public Plugin myinfo =
{
	name        = "[VIP] Куб льда",
	author      = "Drimer",
	version     = "1.0",
	url         = "http://hlmod.ru"
};

char g_sFeature[] = "VIP_ICE";

ConVar fLifeTime;

public void OnPluginStart()
{
	fLifeTime = CreateConVar("sm_vip_icetime",		"2.0",		"Длительность заморозки.");
	
	AutoExecConfig(true, "vip_ice", "vip");
	
	if(VIP_IsVIPLoaded())
	{
		VIP_OnVIPLoaded();
	}
	
	HookEvent("player_hurt", Event_PlayerHurt);
	
	LoadTranslations("vip_modules.phrases");
}

public OnPluginEnd() 
{
	VIP_UnregisterFeature(g_sFeature);
}

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, INT, _, _, OnItemDisplay);
}

public bool:OnItemDisplay(iClient, const String:sFeatureName[], String:sDisplay[], maxlen)
{
	if(VIP_IsClientFeatureUse(iClient, g_sFeature))
	{
		SetGlobalTransTarget(iClient);
		Format(sDisplay, maxlen, "%t [%i%]", "VIP_ICE", VIP_GetClientFeatureInt(iClient, g_sFeature));
		return true;
	}

	return false;
}


public OnMapStart()
{
	PrecacheModel("models/spree/spree.mdl");
	PrecacheSound("physics/glass/glass_impact_bullet4.wav");
	
	/*
	AddFileToDownloadsTable("models/spree/spree.mdl");
	AddFileToDownloadsTable("models/spree/spree.dx80.vtx");
	AddFileToDownloadsTable("models/spree/spree.dx90.vtx");
	AddFileToDownloadsTable("models/spree/spree.phy");
	AddFileToDownloadsTable("models/spree/spree.sw.vtx");
	AddFileToDownloadsTable("models/spree/spree.vvd");
	AddFileToDownloadsTable("materials/models/spree/spree.vtf");
	AddFileToDownloadsTable("materials/models/hypy/hype.vmt");
	*/
}

public void Event_PlayerHurt(Event hEvent, const char[] sEvName, bool bDontBroadcast)
{
	int attacker = GetClientOfUserId(hEvent.GetInt("attacker"));
	int iClient = GetClientOfUserId(hEvent.GetInt("userid"));
	if(attacker && iClient && IsClientInGame(iClient) && GetClientTeam(iClient) != 2 && VIP_IsClientVIP(attacker) && VIP_IsClientFeatureUse(attacker, g_sFeature))
	{
		if(GetRandomInt(0,100) <= VIP_GetClientFeatureInt(iClient,g_sFeature))
		{
			float clientPos[3];
			GetClientAbsOrigin(iClient, clientPos);
			int iEnt = CreateEntityByName("prop_dynamic_override");
			if (iEnt != -1 && IsValidEntity(iEnt))
			{
				DataPack hPack = new DataPack();
				hPack.WriteCell(iClient);
				hPack.WriteCell(iEnt);
				CreateTimer(fLifeTime.FloatValue, Timer_DeleteIce, hPack);
				//CGOPrintHintText(iClient,"{{#00DFFF==Вы были заморожены на %.2f секунд.}}",fLifeTime.FloatValue);
				EmitSoundToClient(iClient,"physics/glass/glass_impact_bullet4.wav",SOUND_FROM_PLAYER,SNDCHAN_VOICE);
				SetEntityMoveType(iClient, MOVETYPE_NONE);
				SetEntityModel(iEnt, "models/spree/spree.mdl");
				DispatchSpawn(iEnt);
				ActivateEntity(iEnt);
				TeleportEntity(iEnt, clientPos, NULL_VECTOR, NULL_VECTOR); 
			}
		}
	}
}

public Action Timer_DeleteIce(Handle hTimer, Handle hDataPack)
{
	DataPack hPack = view_as<DataPack>(hDataPack);
	hPack.Reset();
	int iClient = hPack.ReadCell();
	int iEnt = hPack.ReadCell();
	if(IsValidEntity(iEnt))
	{
		AcceptEntityInput(iEnt, "Kill");
	}
	if (IsClientInGame(iClient)) {
		EmitSoundToClient(iClient,"physics/glass/glass_impact_bullet4.wav",SOUND_FROM_PLAYER,SNDCHAN_VOICE);
		SetEntityMoveType(iClient, MOVETYPE_WALK);
	}
	delete hPack;
	
	return Plugin_Stop;
}
